/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContact type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContact{}

// MessageContact struct for MessageContact
type MessageContact struct {
	Vcard *string `json:"vcard,omitempty"`
	Name *MessageContactName `json:"name,omitempty"`
	Org *MessageContactOrg `json:"org,omitempty"`
	Birthday *string `json:"birthday,omitempty"`
	Photo *MessageContactPhoto `json:"photo,omitempty"`
	Phones []MessageContactPhone `json:"phones,omitempty"`
	Addresses []MessageContactAddress `json:"addresses,omitempty"`
	Emails []MessageContactEmail `json:"emails,omitempty"`
	Urls []MessageContactUrl `json:"urls,omitempty"`
	Ims []MessageContactIM `json:"ims,omitempty"`
}

// NewMessageContact instantiates a new MessageContact object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContact() *MessageContact {
	this := MessageContact{}
	return &this
}

// NewMessageContactWithDefaults instantiates a new MessageContact object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactWithDefaults() *MessageContact {
	this := MessageContact{}
	return &this
}

// GetVcard returns the Vcard field value if set, zero value otherwise.
func (o *MessageContact) GetVcard() string {
	if o == nil || IsNil(o.Vcard) {
		var ret string
		return ret
	}
	return *o.Vcard
}

// GetVcardOk returns a tuple with the Vcard field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetVcardOk() (*string, bool) {
	if o == nil || IsNil(o.Vcard) {
		return nil, false
	}
	return o.Vcard, true
}

// HasVcard returns a boolean if a field has been set.
func (o *MessageContact) HasVcard() bool {
	if o != nil && !IsNil(o.Vcard) {
		return true
	}

	return false
}

// SetVcard gets a reference to the given string and assigns it to the Vcard field.
func (o *MessageContact) SetVcard(v string) {
	o.Vcard = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *MessageContact) GetName() MessageContactName {
	if o == nil || IsNil(o.Name) {
		var ret MessageContactName
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetNameOk() (*MessageContactName, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *MessageContact) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given MessageContactName and assigns it to the Name field.
func (o *MessageContact) SetName(v MessageContactName) {
	o.Name = &v
}

// GetOrg returns the Org field value if set, zero value otherwise.
func (o *MessageContact) GetOrg() MessageContactOrg {
	if o == nil || IsNil(o.Org) {
		var ret MessageContactOrg
		return ret
	}
	return *o.Org
}

// GetOrgOk returns a tuple with the Org field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetOrgOk() (*MessageContactOrg, bool) {
	if o == nil || IsNil(o.Org) {
		return nil, false
	}
	return o.Org, true
}

// HasOrg returns a boolean if a field has been set.
func (o *MessageContact) HasOrg() bool {
	if o != nil && !IsNil(o.Org) {
		return true
	}

	return false
}

// SetOrg gets a reference to the given MessageContactOrg and assigns it to the Org field.
func (o *MessageContact) SetOrg(v MessageContactOrg) {
	o.Org = &v
}

// GetBirthday returns the Birthday field value if set, zero value otherwise.
func (o *MessageContact) GetBirthday() string {
	if o == nil || IsNil(o.Birthday) {
		var ret string
		return ret
	}
	return *o.Birthday
}

// GetBirthdayOk returns a tuple with the Birthday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetBirthdayOk() (*string, bool) {
	if o == nil || IsNil(o.Birthday) {
		return nil, false
	}
	return o.Birthday, true
}

// HasBirthday returns a boolean if a field has been set.
func (o *MessageContact) HasBirthday() bool {
	if o != nil && !IsNil(o.Birthday) {
		return true
	}

	return false
}

// SetBirthday gets a reference to the given string and assigns it to the Birthday field.
func (o *MessageContact) SetBirthday(v string) {
	o.Birthday = &v
}

// GetPhoto returns the Photo field value if set, zero value otherwise.
func (o *MessageContact) GetPhoto() MessageContactPhoto {
	if o == nil || IsNil(o.Photo) {
		var ret MessageContactPhoto
		return ret
	}
	return *o.Photo
}

// GetPhotoOk returns a tuple with the Photo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetPhotoOk() (*MessageContactPhoto, bool) {
	if o == nil || IsNil(o.Photo) {
		return nil, false
	}
	return o.Photo, true
}

// HasPhoto returns a boolean if a field has been set.
func (o *MessageContact) HasPhoto() bool {
	if o != nil && !IsNil(o.Photo) {
		return true
	}

	return false
}

// SetPhoto gets a reference to the given MessageContactPhoto and assigns it to the Photo field.
func (o *MessageContact) SetPhoto(v MessageContactPhoto) {
	o.Photo = &v
}

// GetPhones returns the Phones field value if set, zero value otherwise.
func (o *MessageContact) GetPhones() []MessageContactPhone {
	if o == nil || IsNil(o.Phones) {
		var ret []MessageContactPhone
		return ret
	}
	return o.Phones
}

// GetPhonesOk returns a tuple with the Phones field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetPhonesOk() ([]MessageContactPhone, bool) {
	if o == nil || IsNil(o.Phones) {
		return nil, false
	}
	return o.Phones, true
}

// HasPhones returns a boolean if a field has been set.
func (o *MessageContact) HasPhones() bool {
	if o != nil && !IsNil(o.Phones) {
		return true
	}

	return false
}

// SetPhones gets a reference to the given []MessageContactPhone and assigns it to the Phones field.
func (o *MessageContact) SetPhones(v []MessageContactPhone) {
	o.Phones = v
}

// GetAddresses returns the Addresses field value if set, zero value otherwise.
func (o *MessageContact) GetAddresses() []MessageContactAddress {
	if o == nil || IsNil(o.Addresses) {
		var ret []MessageContactAddress
		return ret
	}
	return o.Addresses
}

// GetAddressesOk returns a tuple with the Addresses field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetAddressesOk() ([]MessageContactAddress, bool) {
	if o == nil || IsNil(o.Addresses) {
		return nil, false
	}
	return o.Addresses, true
}

// HasAddresses returns a boolean if a field has been set.
func (o *MessageContact) HasAddresses() bool {
	if o != nil && !IsNil(o.Addresses) {
		return true
	}

	return false
}

// SetAddresses gets a reference to the given []MessageContactAddress and assigns it to the Addresses field.
func (o *MessageContact) SetAddresses(v []MessageContactAddress) {
	o.Addresses = v
}

// GetEmails returns the Emails field value if set, zero value otherwise.
func (o *MessageContact) GetEmails() []MessageContactEmail {
	if o == nil || IsNil(o.Emails) {
		var ret []MessageContactEmail
		return ret
	}
	return o.Emails
}

// GetEmailsOk returns a tuple with the Emails field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetEmailsOk() ([]MessageContactEmail, bool) {
	if o == nil || IsNil(o.Emails) {
		return nil, false
	}
	return o.Emails, true
}

// HasEmails returns a boolean if a field has been set.
func (o *MessageContact) HasEmails() bool {
	if o != nil && !IsNil(o.Emails) {
		return true
	}

	return false
}

// SetEmails gets a reference to the given []MessageContactEmail and assigns it to the Emails field.
func (o *MessageContact) SetEmails(v []MessageContactEmail) {
	o.Emails = v
}

// GetUrls returns the Urls field value if set, zero value otherwise.
func (o *MessageContact) GetUrls() []MessageContactUrl {
	if o == nil || IsNil(o.Urls) {
		var ret []MessageContactUrl
		return ret
	}
	return o.Urls
}

// GetUrlsOk returns a tuple with the Urls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetUrlsOk() ([]MessageContactUrl, bool) {
	if o == nil || IsNil(o.Urls) {
		return nil, false
	}
	return o.Urls, true
}

// HasUrls returns a boolean if a field has been set.
func (o *MessageContact) HasUrls() bool {
	if o != nil && !IsNil(o.Urls) {
		return true
	}

	return false
}

// SetUrls gets a reference to the given []MessageContactUrl and assigns it to the Urls field.
func (o *MessageContact) SetUrls(v []MessageContactUrl) {
	o.Urls = v
}

// GetIms returns the Ims field value if set, zero value otherwise.
func (o *MessageContact) GetIms() []MessageContactIM {
	if o == nil || IsNil(o.Ims) {
		var ret []MessageContactIM
		return ret
	}
	return o.Ims
}

// GetImsOk returns a tuple with the Ims field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContact) GetImsOk() ([]MessageContactIM, bool) {
	if o == nil || IsNil(o.Ims) {
		return nil, false
	}
	return o.Ims, true
}

// HasIms returns a boolean if a field has been set.
func (o *MessageContact) HasIms() bool {
	if o != nil && !IsNil(o.Ims) {
		return true
	}

	return false
}

// SetIms gets a reference to the given []MessageContactIM and assigns it to the Ims field.
func (o *MessageContact) SetIms(v []MessageContactIM) {
	o.Ims = v
}

func (o MessageContact) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContact) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Vcard) {
		toSerialize["vcard"] = o.Vcard
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Org) {
		toSerialize["org"] = o.Org
	}
	if !IsNil(o.Birthday) {
		toSerialize["birthday"] = o.Birthday
	}
	if !IsNil(o.Photo) {
		toSerialize["photo"] = o.Photo
	}
	if !IsNil(o.Phones) {
		toSerialize["phones"] = o.Phones
	}
	if !IsNil(o.Addresses) {
		toSerialize["addresses"] = o.Addresses
	}
	if !IsNil(o.Emails) {
		toSerialize["emails"] = o.Emails
	}
	if !IsNil(o.Urls) {
		toSerialize["urls"] = o.Urls
	}
	if !IsNil(o.Ims) {
		toSerialize["ims"] = o.Ims
	}
	return toSerialize, nil
}

type NullableMessageContact struct {
	value *MessageContact
	isSet bool
}

func (v NullableMessageContact) Get() *MessageContact {
	return v.value
}

func (v *NullableMessageContact) Set(val *MessageContact) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContact) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContact) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContact(val *MessageContact) *NullableMessageContact {
	return &NullableMessageContact{value: val, isSet: true}
}

func (v NullableMessageContact) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContact) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


